/***************************************************************************
 *   Copyright (C) 2006 by Bas Gijzen                                      *
 *   bas@lekkerknagen.nl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation version 2 of the License                 *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cpuchecker.h"

Cpuchecker::Cpuchecker(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
    : KPanelApplet(configFile, type, actions, parent, name)
{
    // Get the current application configuration handle
    ksConfig = config();

    //TODO better picture loading
    QImage image("/usr/kde/3.5/share/icons/default.kde/48x48/apps/kcmprocessor.png");
    QPixmap pixmap;
    pixmap.convertFromImage(image,0);
    PopupLabel *iconLabel = new PopupLabel(this);
    iconLabel->setPixmap(pixmap);

    mainView = new PopupLabel(this,this);
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->addWidget(iconLabel);
    layout->addWidget(mainView);

    update = new Updater(this);
    update->start();
}

Cpuchecker::~Cpuchecker()
{
	update->stopRunning();
	update->wait();
	delete update;
}

void Cpuchecker::executeUpdate(char *newVal)
{
	mainView->setText(QString(newVal));
}

void Cpuchecker::about()
{
    KMessageBox::information(0, i18n("cpu-checker is created by Bas Gijzen \n (bas@lekkerknagen.nl) using KDevelop"));
}


void Cpuchecker::help()
{
    KMessageBox::information(0, i18n("For help visit the website at http://lekkerknagen.nl/cpucheck/"));
}


void Cpuchecker::preferences()
{
    KMessageBox::information(0, i18n("At this moment there are no configuration options"));
}

int Cpuchecker::widthForHeight(int height) const
{
	return 110;
    //return width();
}

int Cpuchecker::heightForWidth(int width) const
{
    return height();
}


extern "C"
{
    KPanelApplet* init( QWidget *parent, const QString& configFile)
    {
        KGlobal::locale()->insertCatalogue("Cpuchecker");
        return new Cpuchecker(configFile, KPanelApplet::Normal,
                             KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                             parent, "Cpuchecker");
    }
}
