/***************************************************************************
 *   Copyright (C) 2006 by Bas Gijzen                                      *
 *   bas@lekkerknagen.nl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "popuplabel.h"

PopupLabel::PopupLabel(QWidget *parent, Cpuchecker *check)
	: KSqueezedTextLabel(parent)
{
	int size = 4;
	int iCount = 0;
	checker = check;
	menu = new KPopupMenu(this);
	menuItems = new QPtrVector<char>(size);	
	
	cpufreq_available_governors *gov = cpufreq_get_available_governors(0)->first;
	do
	{
		char *name = (char*) malloc((strlen(gov->governor)+1) * sizeof(char));
		strcpy(name, gov->governor);				
		
		menu->insertItem(QString(name), iCount);
		if (iCount == size)
		{
			size++;
			menuItems->resize(size);
		}
		menuItems->insert(iCount,name);
		iCount++;
		gov = gov->next;
	} while (gov != NULL);
}


PopupLabel::~PopupLabel()
{
	menuItems->setAutoDelete(true);
	delete menuItems;
	delete menu;
}

void PopupLabel::mousePressEvent ( QMouseEvent * e )
{
	int retVal = menu->exec(this->mapToGlobal(QPoint(0,0)));
	
	if (retVal < 0) return;
	
	if (retVal < menuItems->size())
	{
		char * txt = menuItems->at(retVal);
		char * command = "kdesu \"cpufreq-set -g\" ";
		
		char * str =(char*) malloc(sizeof(char) * (strlen(txt)+strlen(command)+1));
		strncpy(str,command,strlen(command));
		strcpy(str+strlen(command), txt);
		checker->executeUpdate(str);
		system(str);
		free(str);
	}
}