/***************************************************************************
 *   Copyright (C) 2006 by Bas Gijzen                                      *
 *   bas@lekkerknagen.nl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "updater.h"

Updater::Updater(Cpuchecker *check)
 : QThread()
{
	checker = check;
}


Updater::~Updater()
{
}

void Updater::run()
{
	runningNow = true;
	char str[20];
	while (runningNow)
	{
		unsigned long speed = cpufreq_get_freq_kernel(0);
		
		/* borowed this code from cpufrequtils (
		* http://www.kernel.org/pub/linux/utils/kernel/cpufreq/cpufrequtils.html
		* ) and edited this for my own use.
		*/
		unsigned long tmp;

		if (speed > 1000000) {
			tmp = speed % 10000;
			if (tmp >= 5000)
				speed += 10000;
			sprintf (str,"%u.%02u GHz", ((unsigned int) speed/1000000),
				((unsigned int) (speed%1000000)/10000));
		} else if (speed > 100000) {
			tmp = speed % 1000;
			if (tmp >= 500)
				speed += 1000;
			sprintf (str,"%u MHz", ((unsigned int) speed / 1000));
		} else if (speed > 1000) {
			tmp = speed % 100;
			if (tmp >= 50)
				speed += 100;
			sprintf (str,"%u.%01u MHz", ((unsigned int) speed/1000),
				((unsigned int) (speed%1000)/100));
		} else
			sprintf (str,"%lu kHz", speed);

		checker->executeUpdate(str);
		sleep(2);
	}
}

void Updater::stopRunning()
{
	runningNow = false;
}