/***************************************************************************
 *   Copyright (C) 2006 by Bas Gijzen                                      *
 *   bas@lekkerknagen.nl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef UPDATER_H
#define UPDATER_H

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <cpufreq.h>

#include <qthread.h>

#include "cpuchecker.h"

#ifndef CPUCHECKER_H_DECLARED
class Cpuchecker;
#endif

/**
	@author Bas Gijzen <bas@lekkerknagen.nl>
*/
class Updater : public QThread
{
public:
     Updater(Cpuchecker *check);

    ~Updater();

    void run();
    
    void stopRunning();
private:
	Cpuchecker *checker;
	bool runningNow;
};

#define UPDATER_H_DECLARED

#endif
